<?php

/**
 * Created by PhpStorm.
 * Date: 2017/3/31
 * Time: 14:02
 */

namespace General\Controllers\CompanyAuth\Transformers;

use General\Helpers\CommonHelper;
use General\Models\Activity\ActivitySwitch;

class ActivityTransformer
{
    public function transform($item)
    {
        return [
            'id' => $item->id,
            'name' => $item->name,
            'activity_page' => CommonHelper::getActivityUrl($item->distribution_channel_id, $item->activity_page),
            'created_at' => (string) $item->created_at,
            'start_time' => (string)$item->start_time,
            'end_time' => (string)$item->end_time,
            'price' => $item->price ? $item->price : ($item->product ? $item->product->price : 0),
            'orderCount' => $item->orderCount,
            'totalChargeAmount' => $item->totalChargeAmount,
            'successOrderCount' => $item->successOrderCount,
            'pageUserNum' => $item->pageUserNum,
            'is_reader_page_show' => $this->isShowInPage($item->id, $item->distribution_channel_id),
            'is_sign_message_show' => $this->isShowInPage($item->id, $item->distribution_channel_id, 'sign'),
            'successrate' => $item->successrate,
            'is_over' => $item->end_time < date('Y-m-d H:i:s')
        ];
    }

    public function isShowInPage(int $activity_id, int $channel_id, $type = 'reader')
    {
        $info = ActivitySwitch::where('activity_id', $activity_id)->where('distribution_channel_id', $channel_id)->first();
        return $info ? ($type == 'reader' ? $info->is_reader_page_show : ($type == 'sign' ? $info->is_sign_message_show : 1)) : 1;
    }
}
